# NOTE: Derived from blib/lib/Text/AsReadWithoutIntonation.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Text::AsReadWithoutIntonation;

#line 120 "blib/lib/Text/AsReadWithoutIntonation.pm (autosplit into blib/lib/auto/Text/AsReadWithoutIntonation/_wordInSpanish.al)"
sub _wordInSpanish($) {
    my $word = shift;
    chop($word) if (($word =~ /\.$/ && !Text::IdMor::isAcronym($word)) 
                 || ($word =~ /\,$/)
                 || ($word =~ /:$/));
    my $readWord = "";

    if (Text::IdMor::isAcronym($word)) {
        $word =~ s/\.//g;
        $readWord .= _readSymbolBySymbolInSpanish($word);
    } elsif (Text::IdMor::isRomanNumber($word)) {
        my $numReader = new Lingua::ES::Numeros(FORMATO => "");
        my $intVersion = roman2int($word);
        if ($intVersion <= 10) {
            $readWord .= " ".$numReader->ordinal($intVersion);
        } else {
            $readWord .= " ".$numReader->real($intVersion);
        }
    } elsif (Text::IdMor::isWord($word)) {
#         $word =~ tr/A-ZÁ-ÚUÑ/a-zá-úüñ/;
        $word =~ tr/A-Z/a-z/;
        $word =~ s/Á/á/g;
        $word =~ s/É/é/g;
        $word =~ s/Í/í/g;
        $word =~ s/Ó/ó/g;
        $word =~ s/Ú/ú/g;
        $word =~ s/Ü/ü/g;
        $word =~ s/Ñ/ñ/g;
        $readWord = $word;
#         my $utf8 = new String::Multibyte('UTF8');
#         $readWord = $utf8->strtr($word, 
#                                  ["A-Z", "Á-Ú", "Ü", "Ñ"],
#                                  ["a-z", "á-ú", "ü", "ñ"]);
        
    } elsif (Text::IdMor::isInteger($word)) {
        my $numReader = new Lingua::ES::Numeros(FORMATO => "", UNMIL => 0);
        $word = _convertNumbersFromSpanishToEnglishForm($word);
        eval {
            $readWord .= " ".$numReader->cardinal($word);
        };
    } elsif (Text::IdMor::isSpanishRealNumber($word)) {
        my ($ent, $frac) = split /\,/, $word;
        $readWord .= " "._wordInSpanish($ent)." con";
        $frac =~ /^(0*)([^0]*)$/;
        my $fracZeros = $1; my $fracDigits = $2;
        $readWord .= " ".Symbol::Name::inSpanish('0') foreach (split //, $fracZeros);
        $readWord .= " "._wordInSpanish($fracDigits);
    } elsif (Text::IdMor::isRomanNumber($word)) {
        my $numReader = new Lingua::ES::Numeros(FORMATO => "");
        my $intVersion = roman2int($word);
        eval {
        if ($intVersion <= 10) {
            $readWord .= " ".$numReader->ordinal($intVersion);
        } else {
            $readWord .= " ".$numReader->real($intVersion);
        }
        };
    } elsif (Text::IdMor::isOrdinalNumber($word)) {
        my $lastChar = chop($word);  # A bit tricky, but it does the job if not utf8
        my $c2 = chop($word);
        if ($c2 =~ /[0-9]/) {
            $word .= $c2;
            $lastChar = $c2.$c1;
        } else {
            $lastChar = $c2.$lastChar;
        }
        my $gender = $lastChar =~ /º/?'o':'a';
        my $numReader = new Lingua::ES::Numeros(FORMATO => "", UNMIL => 0, SEXO => $gender);
        $word = _convertNumbersFromSpanishToEnglishForm($word);
        eval {
        $readWord .= " ".$numReader->ordinal($word);
        };
#     } elsif (Text::IdMor::isURL($word)) {
#         my @items = split( /\/+/, $word);
#         $readWord .= " "._readSymbolBySymbolInSpanish(shift @items); # read protocol
#         $readWord .= " ".Symbol::Name::inSpanish(':');
#         $readWord .= " ".Symbol::Name::inSpanish('/');
#         $readWord .= " ".Symbol::Name::inSpanish('/');
#         while (@items) {
#             my $item = shift @items;
#             my @byDot = split(/\./, $item);
#             while (@byDot) {
#                 my $deeperItem = shift;
#                 if ($deeperItem eq "www" ||
#                     $deeperItem eq "html" ||
#                     $deeperItem eq "htm"  ||
#                     $deeperItem eq "sgml" ||
#                     $deeperItem eq "asp"  ||
#                     $deeperItem eq "jsp") { # consider as an achronym)
#                     $readWord .= " "._readSymbolBySymbolInSpanish($deeperItem);
#                 } else {
#                     $readWord .= " "._wordInSpanish($deeperItem);
#                 }
#                 $readWord .= " ".Symbol::Name::inSpanish('.') if (@byDot);
#             }
#             $readWord .= " ".Symbol::Name::inSpanish('/') if (@items);
#         }
#     } elsif (Text::IdMor::isEMail($word)) {
#         
    } elsif ($word =~ /[¡!¡?"]/) {
        $word =~ s/[¡!¡?"]//g;
        $readWord .= _wordInSpanish($word);
    } elsif ($word =~ /^([^$€%\@\+=\(\)]*)(\$|€|%|\@|\+|=|\(|\))(.*)$/) { #(\$|€|%|\@|\+|=|\(|\))
        my $beforeSymbol = $1; my $symbol = $2; my $afterSymbol = $3;
        $readWord .= " "._wordInSpanish($beforeSymbol) if $beforeSymbol;
        $readWord .= " ".Symbol::Name::inSpanish($symbol);
        $readWord .= " "._wordInSpanish($afterSymbol) if $afterSymbol;
    } else {
        my $supportedSymbols = Symbol::Name::supportedSpanishSymbols();
        my $supportedSymbolsEnum = join('', @$supportedSymbols);
        my @symbols = split //, $word;
        my $nOriginalSymbols = @symbols;
        shift @symbols unless (grep /[$supportedSymbolsEnum]/, $symbols[0]);
        pop @symbols if (@symbols && !grep /[$supportedSymbolsEnum]/, $symbols[-1]);
        if (@symbols == $nOriginalSymbols) {
            $readWord = _readSymbolBySymbolInSpanish($word);
        } else {
            $readWord = _wordInSpanish(join('', @symbols));
        }
    }

    $readWord =~ s/^\s+//;
    $readWord =~ s/\s+$//;

    return $readWord;
}

# end of Text::AsReadWithoutIntonation::_wordInSpanish
1;
